searchNodes=[{"doc":"","ref":"ExOpenAi.html","title":"ExOpenAi","type":"module"},{"doc":"The main module for the ExOpenAi API client. Provides a wrapper around Httpoison for making requests to the OpenAI API.","ref":"ExOpenAi.Api.html","title":"ExOpenAi.Api","type":"module"},{"doc":"Builds the authorization header for the request.","ref":"ExOpenAi.Api.html#auth_header/1","title":"ExOpenAi.Api.auth_header/1","type":"function"},{"doc":"Builds the actual authorization header for the request. Examples iex&gt; ExOpenAi.Api.auth_header([], {&quot;api123&quot;, &quot;org345&quot;}) [{&quot;Authorization&quot;, &quot;Bearer api123&quot;}, {&quot;OpenAI-Organization&quot;, &quot;org345&quot;}] iex&gt; ExOpenAi.Api.auth_header([], {&quot;api123&quot;, nil}) [{&quot;Authorization&quot;, &quot;Bearer api123&quot;}]","ref":"ExOpenAi.Api.html#auth_header/2","title":"ExOpenAi.Api.auth_header/2","type":"function"},{"doc":"Create a new resource in the OpenAI API with a POST request. Examples ExOpenAi.Api . create ( ExOpenAi.Completion , [ prompt : &quot;tell me a joke&quot; , max_tokens : 500 ] ) { :ok , % Completion { ... } } ExOpenAi.Api . create ( ExOpenAi.Completion , [ ] ) { :error , %{ &quot;model&quot; =&gt; &quot;model is required&quot; } , 400 }","ref":"ExOpenAi.Api.html#create/3","title":"ExOpenAi.Api.create/3","type":"function"},{"doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#delete/3","title":"ExOpenAi.Api.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#delete!/3","title":"ExOpenAi.Api.delete!/3","type":"function"},{"doc":"","ref":"ExOpenAi.Api.html#format_data/1","title":"ExOpenAi.Api.format_data/1","type":"function"},{"doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#get/3","title":"ExOpenAi.Api.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#get!/3","title":"ExOpenAi.Api.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#head/3","title":"ExOpenAi.Api.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#head!/3","title":"ExOpenAi.Api.head!/3","type":"function"},{"doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#options/3","title":"ExOpenAi.Api.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#options!/3","title":"ExOpenAi.Api.options!/3","type":"function"},{"doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#patch/4","title":"ExOpenAi.Api.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#patch!/4","title":"ExOpenAi.Api.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#post/4","title":"ExOpenAi.Api.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#post!/4","title":"ExOpenAi.Api.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1 .","ref":"ExOpenAi.Api.html#process_headers/1","title":"ExOpenAi.Api.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1 .","ref":"ExOpenAi.Api.html#process_request_body/1","title":"ExOpenAi.Api.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1 .","ref":"ExOpenAi.Api.html#process_request_headers/1","title":"ExOpenAi.Api.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1 .","ref":"ExOpenAi.Api.html#process_request_options/1","title":"ExOpenAi.Api.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1 .","ref":"ExOpenAi.Api.html#process_request_params/1","title":"ExOpenAi.Api.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1 .","ref":"ExOpenAi.Api.html#process_request_url/1","title":"ExOpenAi.Api.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1 .","ref":"ExOpenAi.Api.html#process_response/1","title":"ExOpenAi.Api.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1 .","ref":"ExOpenAi.Api.html#process_response_body/1","title":"ExOpenAi.Api.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1 .","ref":"ExOpenAi.Api.html#process_response_chunk/1","title":"ExOpenAi.Api.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1 .","ref":"ExOpenAi.Api.html#process_response_headers/1","title":"ExOpenAi.Api.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1 .","ref":"ExOpenAi.Api.html#process_response_status_code/1","title":"ExOpenAi.Api.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1 .","ref":"ExOpenAi.Api.html#process_status_code/1","title":"ExOpenAi.Api.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1 .","ref":"ExOpenAi.Api.html#process_url/1","title":"ExOpenAi.Api.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information.","ref":"ExOpenAi.Api.html#put/4","title":"ExOpenAi.Api.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#put!/4","title":"ExOpenAi.Api.put!/4","type":"function"},{"doc":"Issues an HTTP request using an HTTPoison.Request struct. This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request = % HTTPoison.Request { method : :post , url : &quot;https://my.website.com&quot; , body : &quot;{ \\&quot; foo \\&quot; : 3}&quot; , headers : [ { &quot;Accept&quot; , &quot;application/json&quot; } ] } request ( request )","ref":"ExOpenAi.Api.html#request/1","title":"ExOpenAi.Api.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3 , post/4 , put/4 , etc Args: method - HTTP method as an atom ( :get , :head , :post , :put , :delete , etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}] ) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} , {:ok, async_response} , or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise. Redirect handling If the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301 , 302 or 307 . If the method is set to :post , then the only status_code that get's automatically followed is 303 . If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get . Examples request ( :post , &quot;https://my.website.com&quot; , &quot;{ \\&quot; foo \\&quot; : 3}&quot; , [ { &quot;Accept&quot; , &quot;application/json&quot; } ] )","ref":"ExOpenAi.Api.html#request/5","title":"ExOpenAi.Api.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"ExOpenAi.Api.html#request!/5","title":"ExOpenAi.Api.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"ExOpenAi.Api.html#start/0","title":"ExOpenAi.Api.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse . See request!/5 for more detailed information.","ref":"ExOpenAi.Api.html#stream_next/1","title":"ExOpenAi.Api.stream_next/1","type":"function"},{"doc":"","ref":"ExOpenAi.Api.html#t:body/0","title":"ExOpenAi.Api.body/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:data/0","title":"ExOpenAi.Api.data/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:headers/0","title":"ExOpenAi.Api.headers/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:method/0","title":"ExOpenAi.Api.method/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:options/0","title":"ExOpenAi.Api.options/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:params/0","title":"ExOpenAi.Api.params/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:request/0","title":"ExOpenAi.Api.request/0","type":"type"},{"doc":"","ref":"ExOpenAi.Api.html#t:url/0","title":"ExOpenAi.Api.url/0","type":"type"},{"doc":"Represents a chat request to the OpenAI API. OpenAI API Docs Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; ExOpenAi.Chat . create ( params ) { :ok , % ExOpenAi.Chat { ... } } iex&gt; ExOpenAi.Chat . create ( %{ } ) { :error , %{ } }","ref":"ExOpenAi.Chat.html","title":"ExOpenAi.Chat","type":"module"},{"doc":"","ref":"ExOpenAi.Chat.html#create/2","title":"ExOpenAi.Chat.create/2","type":"function"},{"doc":"","ref":"ExOpenAi.Chat.html#do_new/2","title":"ExOpenAi.Chat.do_new/2","type":"function"},{"doc":"","ref":"ExOpenAi.Chat.html#keep_it_simple/2","title":"ExOpenAi.Chat.keep_it_simple/2","type":"function"},{"doc":"","ref":"ExOpenAi.Chat.html#new/0","title":"ExOpenAi.Chat.new/0","type":"function"},{"doc":"","ref":"ExOpenAi.Chat.html#new/1","title":"ExOpenAi.Chat.new/1","type":"function"},{"doc":"","ref":"ExOpenAi.Chat.html#t:t/0","title":"ExOpenAi.Chat.t/0","type":"type"},{"doc":"Represents a chat request to the OpenAI API. OpenAI API Docs This module allows you to add a message to the list of messages in the request as well as validate any request to the Chat resource. Examples iex&gt; params = %{ ...&gt; model : &quot;text-model&quot; , ...&gt; messages : [ ...&gt; %{ content : &quot;hello&quot; } ...&gt; ] ...&gt; } iex&gt; ExOpenAi.ChatRequest . create ( params ) { :ok , % ExOpenAi.Chat { ... } } iex&gt; ExOpenAi.ChatRequest . do_append ( params , %{ content : &quot;world&quot; } ) %{ model : &quot;text-model&quot; , messages : [ %{ content : &quot;hello&quot; } , %{ content : &quot;world&quot; } ] }","ref":"ExOpenAi.ChatRequest.html","title":"ExOpenAi.ChatRequest","type":"module"},{"doc":"Builds the create chat request and validates the required fields.","ref":"ExOpenAi.ChatRequest.html#create/1","title":"ExOpenAi.ChatRequest.create/1","type":"function"},{"doc":"","ref":"ExOpenAi.ChatRequest.html#delete_invalid_fields/2","title":"ExOpenAi.ChatRequest.delete_invalid_fields/2","type":"function"},{"doc":"Builds the chat messages by appending to the list of messages in the map.","ref":"ExOpenAi.ChatRequest.html#do_append/2","title":"ExOpenAi.ChatRequest.do_append/2","type":"function"},{"doc":"Builds the map by adding to the existing map and updates the map with the attributes passed in.","ref":"ExOpenAi.ChatRequest.html#do_change/2","title":"ExOpenAi.ChatRequest.do_change/2","type":"function"},{"doc":"Ensures that the map has the required fields.","ref":"ExOpenAi.ChatRequest.html#has_required_fields?/2","title":"ExOpenAi.ChatRequest.has_required_fields?/2","type":"function"},{"doc":"Prepares the map by removing any fields that are not in the list of fields. and ensures required fields are present.","ref":"ExOpenAi.ChatRequest.html#prepare/3","title":"ExOpenAi.ChatRequest.prepare/3","type":"function"},{"doc":"Represents a completion request to the OpenAI API. OpenAI API Docs Examples TODO: EXAMPLES TODO: ENFORCE REQUIRED FIELDS","ref":"ExOpenAi.Completion.html","title":"ExOpenAi.Completion","type":"module"},{"doc":"","ref":"ExOpenAi.Completion.html#create/2","title":"ExOpenAi.Completion.create/2","type":"function"},{"doc":"","ref":"ExOpenAi.Completion.html#do_new/2","title":"ExOpenAi.Completion.do_new/2","type":"function"},{"doc":"","ref":"ExOpenAi.Completion.html#keep_it_simple/2","title":"ExOpenAi.Completion.keep_it_simple/2","type":"function"},{"doc":"","ref":"ExOpenAi.Completion.html#new/0","title":"ExOpenAi.Completion.new/0","type":"function"},{"doc":"","ref":"ExOpenAi.Completion.html#new/1","title":"ExOpenAi.Completion.new/1","type":"function"},{"doc":"Stores the configuration for the ExOpenAi client. All settings also accept {:system, &quot;ENV_VAR_NAME&quot;} to read their values from environment variables at runtime","ref":"ExOpenAi.Config.html","title":"ExOpenAi.Config","type":"module"},{"doc":"Returns the api_key, set it in mix.exs config :ex_open_ai, api_key: &quot;API_KEY&quot;","ref":"ExOpenAi.Config.html#api_key/0","title":"ExOpenAi.Config.api_key/0","type":"function"},{"doc":"A wrapper around Application.get_env/2 , providing automatic support for {:system, &quot;VARIABLE&quot;} .","ref":"ExOpenAi.Config.html#from_env/3","title":"ExOpenAi.Config.from_env/3","type":"function"},{"doc":"Returns the organization, set it in mix.exs config :ex_open_ai, organization: &quot;ORGANIZATION&quot;","ref":"ExOpenAi.Config.html#organization/0","title":"ExOpenAi.Config.organization/0","type":"function"},{"doc":"Represents an edit request to the OpenAI API. OpenAI API Docs Examples","ref":"ExOpenAi.Edit.html","title":"ExOpenAi.Edit","type":"module"},{"doc":"","ref":"ExOpenAi.Edit.html#create/2","title":"ExOpenAi.Edit.create/2","type":"function"},{"doc":"","ref":"ExOpenAi.Edit.html#do_new/2","title":"ExOpenAi.Edit.do_new/2","type":"function"},{"doc":"","ref":"ExOpenAi.Edit.html#keep_it_simple/2","title":"ExOpenAi.Edit.keep_it_simple/2","type":"function"},{"doc":"","ref":"ExOpenAi.Edit.html#new/0","title":"ExOpenAi.Edit.new/0","type":"function"},{"doc":"","ref":"ExOpenAi.Edit.html#new/1","title":"ExOpenAi.Edit.new/1","type":"function"},{"doc":"Represents an embedding request to the OpenAI API. OpenAI API Docs","ref":"ExOpenAi.Embedding.html","title":"ExOpenAi.Embedding","type":"module"},{"doc":"","ref":"ExOpenAi.Embedding.html#create/2","title":"ExOpenAi.Embedding.create/2","type":"function"},{"doc":"","ref":"ExOpenAi.Embedding.html#do_new/2","title":"ExOpenAi.Embedding.do_new/2","type":"function"},{"doc":"","ref":"ExOpenAi.Embedding.html#keep_it_simple/2","title":"ExOpenAi.Embedding.keep_it_simple/2","type":"function"},{"doc":"","ref":"ExOpenAi.Embedding.html#new/0","title":"ExOpenAi.Embedding.new/0","type":"function"},{"doc":"","ref":"ExOpenAi.Embedding.html#new/1","title":"ExOpenAi.Embedding.new/1","type":"function"},{"doc":"Represents a new image request to the OpenAI API. OpenAI API Docs Examples","ref":"ExOpenAi.NewImage.html","title":"ExOpenAi.NewImage","type":"module"},{"doc":"","ref":"ExOpenAi.NewImage.html#create/2","title":"ExOpenAi.NewImage.create/2","type":"function"},{"doc":"","ref":"ExOpenAi.NewImage.html#do_new/2","title":"ExOpenAi.NewImage.do_new/2","type":"function"},{"doc":"","ref":"ExOpenAi.NewImage.html#keep_it_simple/2","title":"ExOpenAi.NewImage.keep_it_simple/2","type":"function"},{"doc":"","ref":"ExOpenAi.NewImage.html#new/0","title":"ExOpenAi.NewImage.new/0","type":"function"},{"doc":"","ref":"ExOpenAi.NewImage.html#new/1","title":"ExOpenAi.NewImage.new/1","type":"function"},{"doc":"Parses the response from the OpenAI API.","ref":"ExOpenAi.Parser.html","title":"ExOpenAi.Parser","type":"module"},{"doc":"Parse a response expected to contain a resource. If you pass in a module as the first argument, the JSON will be parsed into that module's __struct__ . Examples Given you have a module named Resource , defined like this: defmodule Resource do defstruct sid : nil end You can parse JSON into that module's struct like so: iex&gt; response = %{ body : &quot;{ \\&quot; id \\&quot; : \\&quot; cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7 \\&quot; }&quot; , status_code : 200 } ...&gt; ExOpenAi.Parser . parse ( response , Resource , nil ) { :ok , % Resource { id : &quot;cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7&quot; } } You can also parse into a regular map if you want. iex&gt; response = %{ body : &quot;{ \\&quot; id \\&quot; : \\&quot; cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7 \\&quot; }&quot; , status_code : 200 } ...&gt; ExOpenAi.Parser . parse ( response , %{ } , nil ) { :ok , %{ &quot;id&quot; =&gt; &quot;cmpl-uqkvlQyYK7bGYrRHQ0eXlWi7&quot; } }","ref":"ExOpenAi.Parser.html#parse/3","title":"ExOpenAi.Parser.parse/3","type":"function"},{"doc":"","ref":"ExOpenAi.Parser.html#t:error/0","title":"ExOpenAi.Parser.error/0","type":"type"},{"doc":"","ref":"ExOpenAi.Parser.html#t:http_status_code/0","title":"ExOpenAi.Parser.http_status_code/0","type":"type"},{"doc":"","ref":"ExOpenAi.Parser.html#t:key/0","title":"ExOpenAi.Parser.key/0","type":"type"},{"doc":"","ref":"ExOpenAi.Parser.html#t:metadata/0","title":"ExOpenAi.Parser.metadata/0","type":"type"},{"doc":"","ref":"ExOpenAi.Parser.html#t:parsed_response/0","title":"ExOpenAi.Parser.parsed_response/0","type":"type"},{"doc":"","ref":"ExOpenAi.Parser.html#t:success/0","title":"ExOpenAi.Parser.success/0","type":"type"},{"doc":"","ref":"ExOpenAi.Parser.html#t:success_delete/0","title":"ExOpenAi.Parser.success_delete/0","type":"type"},{"doc":"The base module for all requests in the ExOpenAi API client. Can be used to prepare, validate and update requests.","ref":"ExOpenAi.Request.html","title":"ExOpenAi.Request","type":"module"},{"doc":"The base module for all resources in the ExOpenAi API client.","ref":"ExOpenAi.Resource.html","title":"ExOpenAi.Resource","type":"module"},{"doc":"Generates the URL for the API request.","ref":"ExOpenAi.URLGenerator.html","title":"ExOpenAi.URLGenerator","type":"module"},{"doc":"Infers the URL for the API request based on the module name.","ref":"ExOpenAi.URLGenerator.html#infer_url/1","title":"ExOpenAi.URLGenerator.infer_url/1","type":"function"},{"doc":"MIT License Copyright (c) 2023 David Astor Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"ExOpenAi is an elixir wrapper for the OpenAI API. All resources return a struct of the resource that was called.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding ex_open_ai to your list of dependencies in mix.exs : def deps do [ { :ex_open_ai , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"To access the OpenAI API you will need to set the following environment or runtime variables in your config/config.exs file: config :ex_open_ai , api_key : &quot;YOUR_API_KEY_FROM_OPEN_AI&quot; organization : &quot;OPTIONAL_ORGANIZATION&quot; # optional You can also use the {:system, &quot;VARIABLE_NAME&quot;} format.","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"ExOpenAi has modules for the supported OpenAI API resource. At the time of release not all endpoints are supported, there will be more coming soon. For example the &quot;Completion&quot; resource is available through the ExOpenAi.Completion module. Almost every single resource can be called with the create function. iex&gt; ExOpenAi.Completion . create ( %{ model : &quot;text-davinci-003&quot; , prompt : &quot;Tell me a funny story&quot; } ) { :ok , % ExOpenAi.Completion { object : &quot;text_completion&quot; , id : &quot;cmpl-id&quot; , choices : [ %{ text : &quot;funny story&quot; } ] , created : 1234567890 , usage : %{ completion_tokens : 25 , prompt_tokens : 50 , total_tokens : 75 } } } Will return a ExOpenAi.Completion struct with all the information that the API returns. All the resources support a simple boolean that will extract just the data from the response and return that. iex&gt; ExOpenAi.Completion . create ( %{ model : &quot;text-davinci-003&quot; , prompt : &quot;Tell me a funny story&quot; , n : 3 } , simple : true ) { :ok , [ &quot;funny story one&quot; , &quot;funny story 2&quot; , &quot;funny story 3&quot; ] }","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Introducing ExOpenAi.Requests. These are modules to help you prepare and make requests that return resources. ChatRequest has the do_append/2 function to add messages to the Chat resource. All resources have a .create/1 function that will take in a map and validate that the required fields are present as well as remove any fields that OpenAi API will not like. ExOpenAi.ChatRequest . create ( %{ model : &quot;gpt-3.5-turbo&quot; , messages : [ %{ role : &quot;system&quot; , content : &quot;You are a good bot&quot; } ] } ) &gt;&gt; % ExOpenAi.Chat { id : &quot;cmpl-123451234&quot; , choices : ... }","ref":"readme.html#requests","title":"Overview - Requests","type":"extras"},{"doc":"As of initial release the following resources are supported with more to come: Completions Chat Edits Embeddings Image Generation","ref":"readme.html#supported-resources","title":"Overview - Supported Resources","type":"extras"},{"doc":"Copyright (c) 2023 David Astor ExOpenAi is licensed under the MIT license. For more details see the LICENSE file at the root of the repo. Elixir is licensed under the Apache 2 license. OpenAI is a trademark of OpenAI","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]